'use strict';

module.exports = function(app) {
  app.middleware = Object.assign(app.middleware || {}, {
    error: (error, req, res, next) => {
      if (res.re) return;
      if (error) return res.status(error.code||500).send(error.message||'server error');
      if (res.result === undefined) return res.status(200).json(null);

      return res.status(200).json({status:'SUCCESS', data: res.result});
    },
    result: (req,res, next) => {
      if (res.re) return;
      if (res.result === undefined) return next();
      return res.status(200)[typeof(res.result) === 'string' ? 'send' : 'json'](res.result);
    },
    notfound: (req, res, next) => {
      return res.status(404).send('not found');
    }
  });
};
